from cStringIO import StringIO
gb = StringIO()
lang='enu'
from ctypes import *
import ctypes.wintypes
import config
from ctypes import wintypes
import threading, os, Queue, re
import nvwave
user32 = windll.user32
eci = None
tid = None
bgt = None
samples=22050
buffer = create_string_buffer(samples*2)
bgQueue = Queue.Queue()
stopped = threading.Event()
started = threading.Event()
param_event = threading.Event()
Callback = WINFUNCTYPE(c_int, c_int, c_int, c_int, c_void_p)
pitch=2
fluctuation=3
rate=6
vlm=7
lastindex=0
langs={'esm': (131073, 'Latin American Spanish'),
'esp': (131072, 'Castilian Spanish'),
'ptb': (458752, 'Brazilian Portuguese'),
'frc': (196609, 'French Canadian'),
'fra': (196608, 'French'),
'fin': (589824, 'Finnish'),
'deu': (262144, 'German'),
'ita': (327680, 'Italian'),
'enu': (65536, 'American English'),
'eng': (65537, 'British English')}
avLangs=0
eciPath=0
WM_SPEAK = 1025
WM_SILENCE = 1026
WM_PARAM = 1027
WM_VPARAM=1028
WM_COPYVOICE=1029
WM_KILL=1030
params = {}
vparams = {}

audio_queue = Queue.Queue()

user32 = windll.user32
class eciThread(threading.Thread):
 def run(self):
  global vparams, params
  global tid
  tid = windll.kernel32.GetCurrentThreadId()
  msg = wintypes.MSG()
  user32.PeekMessageA(byref(msg), None, 0x400, 0x400, 0)
  (self.dll, self.handle) = eciNew()
  self.dll.eciRegisterCallback(self.handle, callback, None)
  self.dll.eciSetOutputBuffer(self.handle, samples, pointer(buffer))
  self.dll.eciSetParam(self.handle,1, 1)
  self.dll.eciSetParam(self.handle,3, 1) #dictionary off
  self.dictionaryHandle = self.dll.eciNewDict(self.handle)
  self.dll.eciSetDict(self.handle, self.dictionaryHandle)
#0 = main dictionary
  if os.path.exists(os.path.join(os.path.dirname(eciPath), "main.dic")):
   self.dll.eciLoadDict(self.handle, self.dictionaryHandle, 0, os.path.join(os.path.dirname(eciPath), "main.dic"))
  if os.path.exists(os.path.join(os.path.dirname(eciPath), "root.dic")):
   self.dll.eciLoadDict(self.handle, self.dictionaryHandle, 1, os.path.join(os.path.dirname(eciPath), "root.dic"))
  params[9] = self.dll.eciGetParam(self.handle, 9)
  started.set()
  while True:
   user32.GetMessageA(byref(msg), 0, 0, 0)
   user32.TranslateMessage(byref(msg))
   if msg.message == WM_SPEAK:
    txt = string_at(msg.wParam)
    windll.kernel32.GlobalFree(msg.wParam)
    self.dll.eciAddText(self.handle, txt)
    self.dll.eciInsertIndex(self.handle, msg.lParam)
    self.dll.eciSynthesize(self.handle)
   elif msg.message == WM_SILENCE:
    self.dll.eciStop(self.handle)
    try:
     while True:
      bgQueue.get_nowait()
    except:
      pass
    player.stop()
   elif msg.message == WM_PARAM:
    self.dll.eciSetParam(self.handle, msg.lParam, msg.wParam)
    params[msg.lParam] = msg.wParam
    param_event.set()
   elif msg.message == WM_VPARAM:
    (param, val) = msg.wParam, msg.lParam
#don't set unless we have to
#This doesn't fix the rate problem, though.
#    if param in vparams and vparams[param] == val: continue
    self.dll.eciSetVoiceParam(self.handle, 0, msg.wParam, msg.lParam)
    vparams[msg.wParam] = msg.lParam
    param_event.set()
   elif msg.message == WM_COPYVOICE:
    self.dll.eciCopyVoice(self.handle, msg.wParam, 0)
    for i in (rate, pitch, vlm, fluctuation):
     vparams[i] = self.dll.eciGetVoiceParam(self.handle, 0, i)
    param_event.set()
   elif msg.message == WM_KILL:
    self.dll.eciDelete(self.handle)
    stopped.set()
    break
   else:
    user32.DispatchMessageA(byref(msg))

def eciCheck():
 global eciPath
 eciPath=os.path.abspath(os.path.join(os.path.dirname(__file__), r"eloquence\eci.dll"))
 iniCheck()
 return os.path.exists(eciPath)

def iniCheck():
 ini=open(eciPath[:-3]+"ini","r+")
 ini.seek(12)
 tml=ini.readline()
 if tml[:-9] != eciPath[:-8]:
  ini.seek(12)
  tmp=ini.read()
  ini.seek(12)
  ini.write(tmp.replace(tml[:-9], eciPath[:-8]))
  ini.truncate()
 ini.close()

def eciNew():
 global avLangs
 eciCheck()
 eci = windll.LoadLibrary(eciPath)
 b=c_int()
 eci.eciGetAvailableLanguages(0,byref(b))
 avLangs=(c_int*b.value)()
 eci.eciGetAvailableLanguages(byref(avLangs),byref(b))
 if 'eci' in config.conf['speech'] and config.conf['speech']['eci']['voice'] != '': handle=eci.eciNewEx(langs[config.conf['speech']['eci']['voice']][0])
 else: handle=eci.eciNewEx(langs[lang][0])
 for i in (rate, pitch, vlm, fluctuation):
  vparams[i] = eci.eciGetVoiceParam(handle, 0, i)
 return eci,handle

@WINFUNCTYPE(c_int,c_int,c_int,c_long,c_void_p)
def _bgExec(func, *args, **kwargs):
 global bgQueue
 bgQueue.put((func, args, kwargs))
def setLast(lp):
 global lastindex
 lastindex = lp
 #we can use this to set player idle
# player.idle()
def bgPlay(stri):
 if len(stri) == 0: return
 player.feed(stri)
@Callback
def callback (h, ms, lp, dt):
 global gb
#we need to buffer audio until either an index is received,
#or we get 1 or 2 seconds of audio data.
 if ms == 0:
  gb.write(string_at(buffer, lp*2))
  if gb.tell() >= samples*2:
   _bgExec(bgPlay, gb.getvalue())
   gb.truncate(0)
 elif ms==2:
  if gb.tell() > 0:
   _bgExec(bgPlay, gb.getvalue())
   gb.truncate(0)
  if lp != 0xffff:
   _bgExec(setLast, lp)
 return 1

class BgThread(threading.Thread):
 def __init__(self):
  threading.Thread.__init__(self)
  self.setDaemon(True)

 def run(self):
  global isSpeaking
  try:
   while True:
    func, args, kwargs = bgQueue.get()
    if not func:
     break
    func(*args, **kwargs)
    bgQueue.task_done()
  except:
   logging.error("bgThread.run", exc_info=True)

def _bgExec(func, *args, **kwargs):
 global bgQueue
 bgQueue.put((func, args, kwargs))
def str2mem(str):
 buf = c_buffer(str)
 blen = sizeof(buf)
 ptr = windll.kernel32.GlobalAlloc(0x40, blen)
 cdll.msvcrt.memcpy(ptr, ctypes.addressof(buf), blen)
 return ptr

def initialize():
 global eci, player, bgt
 player = nvwave.WavePlayer(1, 11025, 16, outputDevice=config.conf["speech"]["outputDevice"])
 eci = eciThread()
 eci.start()
 started.wait()
 started.clear()
 bgt = BgThread()
 bgt.start()

def speak(text, idx=None):
#Sometimes the synth slows down for one string of text. Why?
#Trying to fix it here.
 if rate in vparams: text = "`vs%d" % (vparams[rate],)+text
 if idx is None: idx = 0xffff
 user32.PostThreadMessageA(tid, WM_SPEAK, str2mem(text), idx)

def stop():
 user32.PostThreadMessageA(tid, WM_SILENCE, 0, 0)

def pause(switch):
 player.pause(switch)

def terminate():
 global bgt, player
 user32.PostThreadMessageA(tid, WM_KILL, 0, 0)
 stopped.wait()
 stopped.clear()
 bgQueue.put((None, None, None))
 eci.join()
 bgt.join()
 player.close()
 player = None
 bgt = None

def set_voice(vl):
  user32.PostThreadMessageA(tid, WM_PARAM, int(vl), 9)

def getVParam(pr):
 return vparams[pr]

def setVParam(pr, vl):
 user32.PostThreadMessageA(tid, WM_VPARAM, pr, vl)
 param_event.wait()
 param_event.clear()

def setVariant(v):
 user32.PostThreadMessageA(tid, WM_COPYVOICE, v, 0)
 param_event.wait()
 param_event.clear()
